commit 9e83ac453fbe383f12c2beea70ab4869ab9af49e
Author: Martin Liska <mliska@suse.cz>
Date:   Sun Nov 28 09:39:40 2021

    d: fix thinko in optimize attr parsing
    
    gcc/d/ChangeLog:
    
            * d-attribs.cc (parse_optimize_options): Fix thinko.
    
    (cherry picked from commit 7a66c4909fd175ba429f39a3ca30be39ea02ae64)

diff --git a/gcc/d/d-attribs.cc b/gcc/d/d-attribs.cc
index 13c7341fdcd..1721f1f2f0b 100644
--- a/gcc/d/d-attribs.cc
+++ b/gcc/d/d-attribs.cc
@@ -854,7 +854,7 @@ parse_optimize_options (tree args)
     {
       unsigned opt_index = decoded_options[i].opt_index;
       if (opt_index >= cl_options_count
-	  && ! (cl_options[opt_index].flags & CL_OPTIMIZATION))
+	  || ! (cl_options[opt_index].flags & CL_OPTIMIZATION))
 	{
 	  ret = false;
 	  warning (OPT_Wattributes,

